package test.jndi.client;

import javax.naming.InitialContext;

import test.jndi.interfaces.RMIClientService;
import test.jndi.interfaces.RMIClientServiceHome;
import test.jndi.remote.TestRemote;

import com.sun.corba.ee.impl.javax.rmi.PortableRemoteObject;

public class TestMain extends PortableRemoteObject implements TestRemote {

    public TestMain() throws Exception {
        super();
    }

// Run this application, after completion of main method kill process
// and run it again, it should fail

    public static void main(String[] args) throws Exception {
        TestMain test = new TestMain();

        test.exportObject(test);

        InitialContext ctx = new InitialContext();
        Object object = ctx.lookup(RMIClientServiceHome.JNDI_NAME);
        RMIClientServiceHome ejbHome = (RMIClientServiceHome) javax.rmi.PortableRemoteObject.narrow(object,
            RMIClientServiceHome.class);
        RMIClientService ejb = ejbHome.create();

        // This call fails
        ejb.registerRemote(test);

        // This call does not
        // ejb.registerRemoteNoFail(test);
        System.out.println("Remote object has been registered");

// If you uncomment lines below it will work Ok
//        Object obj = ctx.lookup(TestRemote.CONTEXT_PATH + "/" + TestRemote.JNDI_NAME);
//        ((TestRemote) obj).hello();
    }

    /**
     * @see test.jndi.remote.TestRemote#hello()
     */
    public void hello() throws Exception {
        System.out.println("Hello !!!");
    }
}
